;C_ESR_Meter
; 1.1.1
; USART, ,   
;:  ..
;       .
;  LCD    .
;        .
;       U2.
; 20.
;    .
;  262144   .
;LCD .
;   LCD  HD44780U     
;       LCD (lcd_out)

.include	"tn2313def.inc"	;  

.list						; 

.def	sotye 		= R0	;   (1)
.def	desyatye 	= R1	;   (2)
.def	edinicy 	= R2	;  (3)
.def	desyatki 	= R3	;  (4)
.def	sotni 		= R4	;   (5)
.def	tyshi 		= R5	;  (6)
.def	des_tysh	= R6	;   (7)
.def	a1 = R7				;1-   a ( )
.def	a2 = R8				;2-   a
.def	a3 = R9				;3-   a
.def	b1 = R10			;1-   b ( )
.def	b2 = R11			;2-   b
.def	b3 = R12			;3-   b
.def	c1 = R13			;1-   c ( )
.def	c2 = R14			;2-   c
.def	c3 = R15			;3-   c
;--------------------------------------------------------
.def	c4 = R16			;4-   c
.def	temp 	= R17		;   
.def	temp2 	= R18		;   
.def	lcd	= R19			;     LCD
.def	z1 	= R20			;1-   z ( )
.def	z2 	= R21			;2-   z
.def	z3 	= R22			;3-   z
.def	z4 	= R23			;4-   z
.def	k_del	= R24		;    
.def	tok_zar	= R25		;   
;.def	autoff	= R28		;   (  YL)
;.def	autoff2	= R29		;     (  YH)

;--------------------------------------------------------
.equ	const1b = 8727829		;        (32768)
.equ	const1m = 8490828		;        (524288)
.equ	const2 = 2		; 100*U1/Ib
.equ	const3 = 3		; 100*U2/Ib
;.equ	const4 = 129		;    USART (9600 /)

.equ	ESRmax=2001			;   ESR (20,00 )
.equ	porog1 = 32700		;     ( U2)
.equ	porog2 = 15001		;     (150 )
.equ	porog3 = 2001		;      (20 )
.equ	d20m = 65535		;   (~20  20) (-9)/6
.equ	d3m = 9999			;   (~3  20) (-9)/6
.equ	d40u = 235			;   (~40  20) (-4)/3
.equ	d1u	=	6			;   (~1  20) (-4)/3
.equ	RS = 2				;
.equ	E = 3				;

;------------------------   EEPROM

.eseg
.org	0x08			;   

n1_1b:
.byte	1				; EEPROM  1-    n1

n1_2b:
.byte	2				; EEPROM  2-    n1

n2_1b:
.byte	3				; EEPROM  1-    n2

n2_2b:
.byte	4				; EEPROM  2-    n2

n2_n1_1b:
.byte	5				; EEPROM  1-    (n2-n1)

n2_n1_2b:
.byte	6				; EEPROM  2-    (n2-n1)

flag:
.byte	7				; EEPROM     

;------------------------  

.cseg
.org	0				;    

;------------------------  

start:	rjmp	init	;   
		rjmp	com_U1	;  0
		rjmp	com_U2	;  1
		reti			;/ 1, 
		reti			;/ 1, ,  
		rjmp	ovtim1	;/ 1,   
		reti			;/ 0,   
		reti			; USART  
		reti			; USART   
		reti			; USART  
		reti			;  
		reti			;     
		reti			;/ 1, ,  
		reti			;/ 0, ,  
		reti			;/ 0, ,  
		reti			;USI   
		reti			;USI 
		reti			;EEPROM 
		reti			;  

;----------------------- 
init:
;----------------------- 

ldi	temp, RAMEND		;   
out	SPL, temp			;    

;----------------------- USART

;cli							;  
;ldi		temp, high(const4)	;    temp
;out		UBRRH, temp			;     USART  
;ldi		temp, low(const4)	;    temp
;out		UBRRL, temp			;     USART  
;ldi		temp, 0b00000000	;   
;out		UCSRA, temp			;
;ldi		temp, 0b00001000	; ,  
;out		UCSRB, temp			;
;ldi		temp, 0b00000110	;   USART (8-, .,   )
;out		UCSRC, temp			;

;-----------------------  

ldi		temp,0b00000100	;PA2  , PA0, PA1  
out		DDRA,temp		;
ldi		temp,0b00000100	; PA2,    PA0, PA1
out		PORTA,temp		;

ldi		temp,0b11111101	;PB0, PB2...PB7  , PB1  
out		DDRB,temp		;
ldi		temp,0b00000000	; PB1...PB7,  PB1     PB0
out		PORTB,temp		;

ldi		temp,0b00110011	;PD0, PD1, PD4...PD5  , PD2, PD3, PD6  
out		DDRD,temp		;
ldi		temp,0b01111111	; PD0, PD1, PD4...PD5    PD2, PD3, PD6
out		PORTD,temp		;

;-----------------------  1

ldi		temp,0b00000000	; ,  
out		TCCR1B,temp		;

;----------------------- 

ldi		temp,0b01110000	; 
out		ACSR,temp		;

;-----------------------   

ldi		temp,0b00000000	;     PD2 (U1)  PD3 (U2)
out		MCUCR,temp		;

ldi		temp,0b00000000	;    1
out		TIMSK,temp

ldi		temp,0b00000000	;  
out		GIMSK,temp		;

;----------------------- LCD (KS0066)

lcd_init:
rcall	del20m			;   (~20)
rcall	del20m			;   (~20)
rcall	del20m			;   (~20)

						; 0010
sbi		PORTB,E			; 
ldi		temp,0b00101000	; (  + )
out		PORTB,temp		;   
rcall	del1u			;   (~1)
cbi		PORTB,E			; 
rcall	del40u			;   (~40)

ldi		lcd,0b00101000	; 0010  1000
rcall	lcd_com			;     LCD

ldi		lcd,0b00001000	; 0000  1000
rcall	lcd_com			;     LCD

ldi		lcd,0b00000001	; 0000  0001
rcall	lcd_com			;     LCD

rcall	del3m			;   (~3)

ldi		lcd,0b00000110	; 0000  0110
rcall	lcd_com			;     LCD

;-----------------------  

cli						;  
clr		k_del			; k_del
clr		tok_zar			; tok_zar
;clr		autoff			; autoff
;clr		autoff2			; autoff2
ldi		lcd,0b00001100	;    
rcall	lcd_com			;

;----------------------- 

ldi		ZL,low(Prvt*2)	;  ZL       Prvt ( )
ldi		ZH,high(Prvt*2)	;  ZH       Prvt ( )
rcall	lcd_all			;      LCD    

main:
clr		c3				; c3 ( 3-   )
sbi		PORTD,0			;    
sbi		PORTD,4			;    
sbi		PORTD,5			;  
clr		temp			;    1
out		TCNT1H,temp		;
out		TCNT1L,temp		;

;-----------------------     

;autoff_check:
;cpi		autoff,255		; autoff  255 (~4'35")
;breq	autoff_check1	; autoff=255,   autoff_check1,  

;cpi		k_del,4			; k_del  4
;brlo	autoff_check00	; k_del<4,   autoff_check00,  

;cpi		autoff2,10		; autoff2  10 (~2'22")
;brlo	bat_check1		; autoff2<10,   bat_check1,  
;rjmp	autoff_check1	; autoff_check1

;autoff_check00:
;cpi		k_del,3			; k_del  3
;brlo	autoff_check0	; k_del<3,   autoff_check0,  

;cpi		autoff2,31		; autoff2  31 (~2'22")
;brlo	bat_check1		; autoff2<31,   bat_check1,  
;rjmp	autoff_check1	; autoff_check1

;autoff_check0:
;cpi		autoff2,100		; autoff2  100 (~2'17")
;brlo	bat_check1		; autoff2<100,   bat_check1,  

;autoff_check1:
;----------------------- 

;ldi		temp,0b01110000	;    Power-Down
;out		MCUCR,temp		;
;sbi		PORTB,0			; 
;sleep					;   Power-Down

;bat_check1:
;clr		z1				; z1
;clr		z2				; z2
;ldi		temp,55			; 55  temp

;bat_check2:
;rcall	del20m			;   (~20)
;dec		temp			; temp  1
;sbis	ACSR,ACO		;    1,   . ,  
;rjmp	bat_check3		; bat_check3
;inc		z1				; z1  1
;rjmp	bat_check4		; bat_check4

;bat_check3:
;inc		z2				; z2  1

;bat_check4:
;cpi		temp,0			; temp  0
;brne	bat_check2		; temp<>0,   bat_check2,  

;cp		z1,z2			; z1  z2
;brlo	pusk_0			; z1<z2,   pusk_0,  

;ldi		ZL,low(Bat*2)	;  ZL       Bat ( )
;ldi		ZH,high(Bat*2)	;  ZH       Bat ( )
;rcall	lcd_all			;      LCD    
;inc		autoff2			; autoff2  1

;-----------------------    

;rcall	USART_ready		;     

;ldi		temp,0xD6		; 0xD6  temp
;out		UDR,temp		;  temp  USART

;rcall	USART_ready		;     

;-----------------------        (~0,3  20)

rcall	del300m			;   (~300)

;cpi		k_del,2			; k_del  2
;brsh	pusk_0			; k_del>=2,   pusk_0,  

;ldi		ZL,low(Gdit*2)	;  ZL       Gdit ( )
;ldi		ZH,high(Gdit*2)	;  ZH       Gdit ( )
;ldi		temp,1			; 1- 
;rcall	lcd_mess		;   

;ldi		ZL,low(Gdit*2)	;  ZL       Gdit ( )
;ldi		ZH,high(Gdit*2)	;  ZH       Gdit ( )
;ldi		temp,2			; 2- 
;rcall	lcd_mess		;   

;pusk_0:
;-----------------------    

;rcall	USART_ready		;     

;ldi		temp,0xC0		; 0xC0  temp
;or		temp,k_del		;  k_del  temp,   temp
;out		UDR,temp		;  temp  USART

;rcall	USART_ready		;     

pusk:
ldi		temp,0b01000000	;     PD2 (U1)
out		GIMSK,temp		;

ldi		temp,0b10000000	;      1
out		TIMSK,temp		;

cbi		PORTD,5			;  

rcall	del1u			;   (~1),    MOSFET

sei						;  

cpi		tok_zar,1		; tok_zar  1
breq	m_tok			; tok_zar=1,   m_tok,  

;-----------------------    

b_tok:
ldi		temp,0b00000001	;  (clk/1)
add		temp,k_del		;    
cbi		PORTD,0			;  
out		TCCR1B,temp		;
rjmp	cikl			; cikl

;-----------------------    

m_tok:
ldi		temp,0b00000001	;  (clk/1)
add		temp,k_del		;    
cbi		PORTD,4			;  
out		TCCR1B,temp		;

cikl:
rjmp	cikl			;

;-----------------------   (  )

clk_up:
cpi		k_del,0			; k_del  0
breq	clk_no_ch		; k_del=0,   clk_no_ch,  
dec		k_del			;   1 (  )
rjmp	clk_pred		; clk_pred

;-----------------------   (  )

clk_down:
clr		tok_zar			; k_del
cpi		k_del,4			; k_del  4.
brlo	clk_down_0		; k_del<4,   clk_down_0,  
rjmp	step3			;  step3 (   )

clk_down_0:
inc		k_del			;   1 (  )

clk_pred:
ldi		ZL,low(Pred*2)	;  ZL       Pred ( )
ldi		ZH,high(Pred*2)	;  ZH       Pred ( )
rcall	lcd_all			;      LCD    
rcall	pred_num		;    
;clr		autoff			; autoff

;-----------------------  "..."

;rcall	USART_ready		;     

;ldi		temp,0xD4		; 0xD4  temp
;out		UDR,temp		;  temp  USART

;rcall	USART_ready		;     

clk_no_ch:
rjmp	main			; main

;-----------------------   (porog1)
;      porog1,     ( step4),
;    porog1,      (  step2)

step1:
ldi		z1,low(porog1)	;   porog1  z1
ldi		z2,high(porog1)	;   porog1  z2
ldi		z3,0			; 0  z3
cp		b1,z1			; b2+b1  z2+z1   
cpc		b2,z2			;
cpc		b3,z3			;
brsh	step4			; b3+b2+b1    z3+z2+z1,   step4,   ( step2)

;-----------------------  
; k_del=0 (clk/1),     ( step4),  k_del<>0,
;      ( clk_up)

step2:
cpi		k_del,0			; k_del  0
breq	step4			; k_del=0,     ( step4)
rjmp	clk_up			;     ( clk_up)

;-----------------------      

step3:
ldi		ZL,low(KZ_Cmx*2)	;  ZL       KZ_Cmx ( )
ldi		ZH,high(KZ_Cmx*2)	;  ZH       KZ_Cmx ( )
rcall	lcd_all				;       LCD    
;ldi		temp,85				;  1, 3, 5, 15, 17, 51, 85, 255 ( 85  50 )
;add		autoff,temp

;-----------------------  "Cx > max"  "ESR < min"

;rcall	USART_ready		;     

;ldi		temp,0xD0		; 0xD0  temp
;out		UDR,temp		;  temp  USART

;rcall	USART_ready		;     

rjmp	main			; main

;-----------------------   

step4:
cpi		tok_zar,1		; tok_zar  1
breq	step6_0			; tok_zar=1,   step6_0,  

;-----------------------  EEPROM

ldi		temp2,flag		;  temp2    EEPROM
rcall	EEPROM_read		;    EEPROM

cpi		temp2,100		; temp2  100
breq	step5			; temp2=100,   step5,  
rjmp	step6			; step6

step5:
ldi		temp2,n1_1b		;  temp2    EEPROM
rcall	EEPROM_read		;    EEPROM
mov		z1,temp2		;    temp2  z1

ldi		temp2,n1_2b		;  temp2    EEPROM
rcall	EEPROM_read		;    EEPROM
mov		z2,temp2		;    temp2  z2

rcall	predel			;  predel

sub		a1,z1			; z1  a1
sbc		a2,z2			; z2  a2   
sbc		a3,temp2		; temp2  a3   

ldi		temp2,n2_1b		;  temp2    EEPROM
rcall	EEPROM_read		;    EEPROM
mov		z1,temp2		;    temp2  z1

ldi		temp2,n2_2b		;  temp2    EEPROM
rcall	EEPROM_read		;    EEPROM
mov		z2,temp2		;    temp2  z2

rcall	predel			;  predel

sub		b1,z1			; z1  b1
sbc		b2,z2			; z2  b2   
sbc		b3,temp2		; temp2  b3   

ldi		temp2,n2_n1_1b	;  temp2    EEPROM
rcall	EEPROM_read		;    EEPROM
mov		z1,temp2		;    temp2  z1

ldi		temp2,n2_n1_2b	;  temp2    EEPROM
rcall	EEPROM_read		;    EEPROM
mov		z2,temp2		;    temp2  z2

rcall	predel			;  predel

sub		c1,z1			; z1  c1
sbc		c2,z2			; z2  c2   
sbc		c3,temp2		; temp2  c3   

;-----------------------  

step6:

push	c1				; c1   ( n2-n1)
push	c2				; c2  
push	c3				; c3  

push	a1				; a1   ( n1)
push	a2				; a2  
push	a3				; a3  
rjmp	step6_1			; step6_1

step6_0:

;----------------------- (c3+c2+c1)*(XH+XL)=(c4+c3+c2+c1)  (n2-n1)*const1b

ldi		XL,low(const1m)		;   const1m  XL
ldi		XH,high(const1m)	;   const1m  XH
rjmp	step6_2				; step6_2

step6_1:
ldi		XL,low(const1b)		;   const1b  XL
ldi		XH,high(const1b)	;   const1b  XH

step6_2:
rcall 	mul16x16		;   16-  

;-----------------------  32...32768   

cpi		k_del,4			;   4 (clk/1024),    divC_32
breq	divC_32			; 

cpi		k_del,3			;   3 (clk/256),    divC_128
breq	divC_128		; 

cpi		k_del,2			;   2 (clk/64),    divC_512
breq	divC_512		; 

cpi		k_del,1			;   1 (clk/8),    divC_4096
breq	divC_4096		; 

divC_32768:
rcall	del32_8			;/8

divC_4096:
rcall	del32_8			;/8

divC_512:
rcall	del32_4			;/4

divC_128:
rcall	del32_4			;/4

divC_32:
rcall	del32_32		;/32

cpi		tok_zar,0		; tok_zar  0
breq	step6_3			; tok_zar=0,   step6_3,  
rcall	del32_2			;/2
rcall	del32_8			;/8
clr		k_del			; k_del
clr		tok_zar			; tok_zar

;-----------------------     - (,  )

rcall	bin2dec			;      - (,  ))

;-----------------------   LCD

rcall	lcd_1str		;     LCD

;-----------------------  1-  7-   USART

;rcall	usart_1_7		;    1-  7-   USART

rjmp	main			; main

step6_3:
ldi		z1,low(porog2)	;   porog2  z1
ldi		z2,high(porog2)	;   porog2  z2
clr		z3				; z3
clr		z4				; z4
cp		c1,z1			; c1  z1
cpc		c2,z2			; c2  z2   
cpc		c3,z3			; c3  z3   
cpc		c4,z4			; c4  z4   
brsh	step6_3_1		; (c4+c3+c2+c1)>=porog2,   step6_3_1,  
ldi		tok_zar,1		; 1  tok_zar

ldi		z1,low(porog3)	;   porog3  z1
ldi		z2,high(porog3)	;   porog3  z2
cp		c1,z1			; c1  z1
cpc		c2,z2			; c2  z2   
cpc		c3,z3			; c3  z3   
cpc		c4,z4			; c4  z4   
brlo	step6_3_0		; (c4+c3+c2+c1)<porog3,   step6_3_0,  
inc		k_del			;   1 (  )

step6_3_0:
rjmp	step7			; step7

step6_3_1:
ldi		z1,0x80			; 1-       (10000000)
ldi		z2,0x96			; 2-      
ldi		z3,0x98			; 3-      
cp		c1,z1			; c1  z1
cpc		c2,z2			; c2  z2   
cpc		c3,z3			; c3  z3   
cpc		c4,z4			; c4  z4   
brlo	step6_4			; (c4+c3+c2+c1)<(z4+z3+z2+z1),   step6_4,  

;----------------------- (c4+c3+c2+c1)/10000=(c3+c2+c1)    (b3+b2+b1)
step6_3_2:
ldi		temp,low(10000)	;   10000  temp
mov		a1,temp			;  temp  a1
ldi		temp,high(10000);   10000  temp
mov		a2,temp			;  temp  a2
clr		a3				; a3

rcall 	div32_16		;   32-  16-  

;-----------------------     -

step6_4:
rcall	bin2dec			;      - ()

;-----------------------   LCD

rcall	lcd_1str		;     LCD
;clr		autoff			; autoff

;-----------------------  1-  7-   USART

step6_5:
;rcall	usart_1_7		;    1-  7-   USART

step7:
pop		c3				;    c3 ( n1)
pop		c2				;    c2
pop		c1				;    c1

;----------------------- (c3+c2+c1)*(XH+XL)=(c4+c3+c2+c1)  (U2/I)*n1

ldi		XL,low(const3)	;   const3  XL
ldi		XH,high(const3)	;   const3  XH
rcall 	mul16x16		;   16-  

mov		z1,c1			;    c1  z1
mov		z2,c2			;    c2  z2
mov		z3,c3			;    c3  z3
mov		z4,c4			;    c4  z4

mov		c1,b1			; 1-  n2  b1  c1
mov		c2,b2			; 2-  n2  b2  c2
mov		c3,b3			; 3-  n2  b3  c3

;----------------------- (c3+c2+c1)*(XH+XL)=(c4+c3+c2+c1)  (U1/I)*n2

ldi		XL,low(const2)	;   const2  XL
ldi		XH,high(const2)	;   const2  XH
rcall 	mul16x16		;   16-  

pop		a3				;    a3 ( n2-n1)
pop		a2				;    a2
pop		a1				;    a1

sub		c1,z1			; z1  c1 ((U1/I)*n2)-((U2/I)*n1)
sbc		c2,z2			; z2  c2   
sbc		c3,z3			; z3  c3   
sbc		c4,z4			; z4  c4   

brpl	step8			;  ,   step8,  
ldi		ZL,low(ESRmn*2)	;  ZL       ESRmn ( )
ldi		ZH,high(ESRmn*2)	;  ZH       ESRmn ( )

;-----------------------  "ESR < 0,01 "

;rcall	USART_ready		;     

;ldi		temp,0xD3		; 0xD3  temp
;out		UDR,temp		;  temp  USART

;rcall	USART_ready		;     

rjmp	step8_0			; step8_0

;----------------------- (c4+c3+c2+c1)/(a3+a2+a1)=(c3+c2+c1)  (b3+b2+b1)  (((U1/I)*n2)-((U2/I)*n1))/(n2-n1)
step8:
rcall 	div32_16		;   32-  16-  

;-----------------------     

clr		c3					; c3
ldi		temp,low(ESRmax)	;   ESRmax  temp
ldi		temp2,high(ESRmax)	;   ESRmax  temp2
cp		c1,temp				; c1  temp
cpc		c2,temp2			; c2  temp2   
brlo	step9				; (c2+c1)< ESRmax,   step9,  
ldi		ZL,low(ESRmx*2)		;  ZL       ESRmx ( )
ldi		ZH,high(ESRmx*2)	;  ZH       ESRmx ( )

;-----------------------  "ESR >20,0 "

;rcall	USART_ready		;     

;ldi		temp,0xD2		; 0xD2  temp
;out		UDR,temp		;  temp  USART

;rcall	USART_ready		;     

step8_0:
ldi		temp,2			; 2- 
rcall	lcd_mess		;   

rjmp	main			; main

;-----------------------   ESR  -

step9:
rcall	bin2dec			;      - (ESR)

;-----------------------   LCD

step10:
rcall	lcd_2str		;     LCD

;----------------------- 8-...11-   USART

;rcall	USART_ready		;     

;ldi		temp,0x80		; 0x80  temp
;or		desyatki,temp	;  desyatki  temp,   desyatki
;out		UDR,desyatki	;  desyatki  USART

;rcall	USART_ready		;     

;ldi		temp,0x90		; 0x90  temp
;or		edinicy,temp	;  edinicy  temp,   edinicy
;out		UDR,edinicy		;  edinicy  USART

;rcall	USART_ready		;     

;ldi		temp,0xA0		; 0xA0  temp
;or		desyatye,temp	;  desyatye  temp,   desyatye
;out		UDR,desyatye	;  desyatye  USART

;rcall	USART_ready		;     

;ldi		temp,0xB0		; 0xB0  temp
;or		sotye,temp		;  sotye  temp,   sotye
;out		UDR,sotye		;  sotye  USART

;rcall	USART_ready		;     

rjmp	main			; main

;-----------------------    LCD

lcd_1str:

;----------------------- 

ldi		lcd,0x80		;  ( 1 )
rcall	lcd_com			;     LCD

;----------------------- "12345"  " 2345"

clr		temp			; temp
cp		des_tysh,temp	;      ,    lcd_1str_4
brne	lcd_1str_4		; 
		
cp		tyshi,temp		;     ,    lcd_1str_3
brne	lcd_1str_3		; 

cp		sotni,temp		;     ,    lcd_1str_2
brne	lcd_1str_2		; 

cp		desyatki,temp	;     ,    lcd_1str_0
brne	lcd_1str_0		; 

;----------------------- " 5,67"  "45,67"

ldi		lcd,0x20		; " " ()
rcall	lcd_dat			; 
rjmp	lcd_1str_1		; lcd_1str_1

lcd_1str_0:
cpi		k_del,4			; k_del  4
brne	lcd_1str_0_1	; k_del<>4,   lcd_1str_0_1

ldi		lcd,0x30		; "0" ()
rcall	lcd_dat			;

ldi		lcd,0x2C		; "," ()
rcall	lcd_dat			; 

lcd_1str_0_1:
ldi		lcd,0x30		;     ()
add		lcd,desyatki	;
rcall	lcd_dat			;   ()

lcd_1str_1:
ldi		lcd,0x30		;     ()
add		lcd,edinicy	;
rcall	lcd_dat			;   ()

cpi		k_del,4			; k_del  4
brne	lcd_1str_1_1	; k_del<>4,   lcd_1str_1_1

ldi		lcd,0x30		;      ()
add		lcd,desyatye	;
rcall	lcd_dat			;    ()

ldi		lcd,0x30		;      ()
add		lcd,sotye		;
rcall	lcd_dat			;    ()

ldi		lcd,0x20		; " " ()
rcall	lcd_dat			; 

rjmp	F_lcd			; F_lcd

lcd_1str_1_1:
ldi		lcd,0x2C		; "," ()
rcall	lcd_dat			; 

ldi		lcd,0x30		;      ()
add		lcd,desyatye	;
rcall	lcd_dat			;    ()

ldi		lcd,0x30		;      ()
add		lcd,sotye		;
rcall	lcd_dat			;    ()
rjmp	uF_lcd			; uF_lcd

;----------------------- "345,6"

lcd_1str_2:
ldi		lcd,0x30		;     ()
add		lcd,sotni		;
rcall	lcd_dat			;   ()

ldi		lcd,0x30		;     ()
add		lcd,desyatki		;
rcall	lcd_dat			;   ()

ldi		lcd,0x30		;     ()
add		lcd,edinicy	;
rcall	lcd_dat			;   ()

ldi		lcd,0x2C		; "," ()
rcall	lcd_dat			; 

ldi		lcd,0x30		;      ()
add		lcd,desyatye	;
rcall	lcd_dat			;    ()
rjmp	uF_lcd			; uF_lcd

;----------------------- " 2345"  "12345"

lcd_1str_3:
ldi		lcd,0x20		; " " ()
rcall	lcd_dat			; 
rjmp	lcd_1str_5		; lcd_1str_5

lcd_1str_4:
ldi		lcd,0x30		;      ()
add		lcd,des_tysh	;
rcall	lcd_dat			;    ()

lcd_1str_5:
ldi		lcd,0x30		;     ()
add		lcd,tyshi		;
rcall	lcd_dat			;   ()

ldi		lcd,0x30		;     ()
add		lcd,sotni		;
rcall	lcd_dat			;   ()

ldi		lcd,0x30		;     ()
add		lcd,desyatki	;
rcall	lcd_dat			;   ()

ldi		lcd,0x30		;     ()
add		lcd,edinicy	;
rcall	lcd_dat			;   ()

uF_lcd:
ldi		lcd,0x20		; " " ()
rcall	lcd_dat			; 

ldi		lcd,0x75		; "u" ()
rcall	lcd_dat			; 

F_lcd:
ldi		lcd,0x46		; "F" ()
rcall	lcd_dat			;
ret						;  

;-----------------------    LCD

lcd_2str:

;----------------------- ESR

ldi		lcd,0xC0		;  ( 2 )
rcall	lcd_com			;

clr		temp			; temp
cp		desyatki,temp	;    ,    lcd_2str_0
breq	lcd_2str_0		; 

ldi		lcd,0x30		;     (ESR)
add		lcd,desyatki			;
rcall	lcd_dat			;   (ESR)
rjmp	lcd_2str_1		;  lcd_2str_1

lcd_2str_0:
ldi		lcd,0x20		; " " (ESR)
rcall	lcd_dat			; 

lcd_2str_1:
ldi		lcd,0x30		;     (ESR)
add		lcd,edinicy			;
rcall	lcd_dat			;   (ESR)

ldi		lcd,0x2C		; "," (ESR)
rcall	lcd_dat			; 

ldi		lcd,0x30		;      (ESR)
add		lcd,desyatye			;
rcall	lcd_dat			;    (ESR)

ldi		lcd,0x30		;      (ESR)
add		lcd,sotye			;
rcall	lcd_dat			;    (ESR)

ldi		lcd,0x20		; " " (ESR)
rcall	lcd_dat			; 

ldi		lcd,0x4F		; "" (ESR)
rcall	lcd_dat			; 

ldi		lcd,0xBC		; "" (ESR)
rcall	lcd_dat			; 
ret						;  

;-----------------------    LCD

lcd_mess:
ldi		z4,8			; 8  z4
cpi		temp,1			; temp  1
brne	lcd_mess_2str	; str   1,   lcd_mess_2str,  

lcd_mess_1str:
ldi		lcd,0x80		;  ( 1 )
rcall	lcd_com			;
rjmp	lcd_mess_0		; lcd_mess_0

lcd_mess_2str:
ldi		lcd,0xC0		;  ( 2 )
rcall	lcd_com			;

lcd_mess_0:
lpm		lcd,Z+			; lcd         Z
rcall	lcd_dat			;
dec		z4				; z4  1
cpi		z4,0			; z4  0
brne	lcd_mess_0		; z4<>0,   lcd_mess_0,  
ret						;  

;-----------------------      LCD     

lcd_all:
ldi		temp,1			; 1- 
rcall	lcd_mess		;   
ldi		temp,2			; 2- 
rcall	lcd_mess		;   
ret						;  

;-----------------------    

pred_num:
ldi		lcd,0x87		;  ( 1 )
rcall	lcd_com			;

ldi		lcd,0x30		;   
add		lcd,k_del		;
inc		lcd				;
rcall	lcd_dat			;
ret						;  

;-----------------------  24    -
;    XL, XH,   des_tysh, tyshi, sotni, desyatki,
;edinicy, desyatye, sotye

bin2dec:
clr		des_tysh		;  
clr		tyshi			; 
clr		sotni			; 
clr		desyatki		; 
clr		edinicy			; 
clr		desyatye		;  
clr		sotye			;  

des_tysh0:
ldi		z1,0x40			; 1000000  z1...z3
ldi		z2,0x42			;
ldi		z3,0x0F			;

des_tysh1:
rcall	c_minus_z		; 1000000
brmi	des_tysh2		;   ,    des_tysh2
inc		des_tysh		;   1   
rjmp	des_tysh1		; des_tysh1

des_tysh2:
rcall	c_plus_z		; 1000000   

tyshi0:
ldi		z1,0xA0			; 100000  z1...z3
ldi		z2,0x86			;
ldi		z3,0x01			;

tyshi1:
rcall	c_minus_z		; 100000
brmi	tyshi2			;   ,    tyshi2
inc		tyshi			;   1  
rjmp	tyshi1			; tyshi1

tyshi2:
rcall	c_plus_z		; 100000   

sotni0:
ldi		z1,0x10			; 10000  z1...z3
ldi		z2,0x27			;
ldi		z3,0x00			;

sotni1:
rcall	c_minus_z		; 10000
brmi	sotni2			;   ,    sotni2
inc		sotni			;   1  
rjmp	sotni1			; sotni1

sotni2:
rcall	c_plus_z		; 10000   

desyatki0:
ldi		z1,0xE8			; 1000  z1...z3
ldi		z2,0x03			;

desyatki1:
rcall	c_minus_z		; 1000
brmi	desyatki2		;   ,    desyatki2
inc		desyatki		;   1  
rjmp	desyatki1		; desyatki1

desyatki2:
rcall	c_plus_z		; 1000   

edinicy0:
ldi		z1,0x64			; 100  z1...z3
ldi		z2,0x00			;

edinicy1:
rcall	c_minus_z		; 100
brmi	edinicy2		;   ,    edinicy2
inc		edinicy			;   1  
rjmp	edinicy1		; edinicy1

edinicy2:
rcall	c_plus_z		; 100   

desyatye0:
ldi		z1,0x0A			; 10  z1...z3

desyatye1:
rcall	c_minus_z		; 10
brmi	desyatye2		;   ,    desyatye2
inc		desyatye		;   1   
rjmp	desyatye1		; desyatye1

desyatye2:
rcall	c_plus_z		; 10   

sotye0:
ldi		z1,0x01			; 1  z1...z3

sotye1:
rcall	c_minus_z		; 1
brmi	bin2dec1		;   ,    bin2dec1
inc		sotye			;   1   
rjmp	sotye1			; sotye1

bin2dec1:
clr		c1				; c1
clr		c2				; c2
clr		c3				; c3
ret						;  

;-----------------------  16-    
;            
;1- : (c4+c3+c2+c1), 2- : (XH+XL), : (c4+c3+c2+c1)

;-----------------------  

mul16x16:
clr		temp			; temp
clr		c4				; c4

;-----------------------  

mul16x16_0:
cp		c1,XL			; 1-  
cpc		c2,XH			; 2-     
cpc		c3,temp			; 3-     
brsh	mul16x16_1		; c3+c2+c1    XH+XL,   mul16x16_1,
push	c1				;  (    )
push	c2				;
push	XL				;
push	XH				;
pop		c2				;
pop		c1				;
pop		XH				;
pop		XL				;

;-----------------------  

mul16x16_1:
mov		a1,c1			; 1-    a1
mov		a2,c2			; 2-    a1
mov		a3,c3			; 3-    a1

;----------------------- 

mul16x16_2:
sbiw	X,1				;   1
cp		XL,temp			;   0
cpc		XH,temp			;   0,   
breq	mul16x16_3		;   ,    mul16x16_3,  
add		c1,a1			; c1  a1,   c1
adc		c2,a2			; c2  a2   ,   c2
adc		c3,a3			; c3  a3   ,   c3
adc		c4,temp			; c4  temp   ,   c4
rjmp	mul16x16_2		; mul16x16_2

mul16x16_3:
ret						;  

;-----------------------  32-   16-  
;: (c4+c3+c2+c1), : (XH+XL), : (c3+c2+c1)     (b3+b2+b1)

div32_16:
clr		temp			; temp
clr		temp2			; temp2
clr		XL				; XL			
clr		XH				; XH	

div32_16_0:
sub		c1,a1			; a1  c1
sbc		c2,a2			; a2  c2   
sbc		c3,a3			; a3  c3   
sbc		c4,temp			; temp  c4   
brcs	div32_16_1		;   ,    div32_16_1
adiw	X,1				; 1    X
adc		temp2,temp		; temp2  temp   ,   temp2
rjmp	div32_16_0		;  div32_16_0

div32_16_1:
mov		c1,XL			; 1-    XL  c1
mov		c2,XH			; 2-    XH  c2
mov		c3,temp2		; 3-    temp2  c3
ret						;  

;-----------------------  32-x    2   

del32_2:
lsr		c4				;/2 ( /2)
ror		c3				;
ror		c2				;
ror		c1				;
ret						;  

;-----------------------  32-x    4   

del32_4:
rcall	del32_2			;/2 ( /2)
rcall	del32_2			;/2 ( /4)
ret						;  

;-----------------------  32-x    8   

del32_8:
rcall	del32_2			;/2 ( /2)
rcall	del32_4			;/4 ( /8)
ret						;  

;-----------------------  32-x    32   

del32_32:
rcall	del32_4			;/4 ( /4)
rcall	del32_8			;/8 ( /32)
ret						;  

;-----------------------  (c3+c2+c1)-(z3+z2+z1)=(c3+c2+c1)

c_minus_z:
sub		c1,z1			;
sbc		c2,z2			;
sbc		c3,z3			;
ret						;  

;-----------------------  (c3+c2+c1)+(z3+z2+z1)=(c3+c2+c1)

c_plus_z:
add		c1,z1			;
adc		c2,z2			;
adc		c3,z3			;
ret						;  

;-----------------------  (~1  20)
;    (3*N)+4

del1u:
ldi		temp2,d1u		; d1u  temp2

del1u_1:
dec		temp2			; temp2  1
brne	del1u_1			;    0,    del1u_1
ret						;  

;-----------------------  (~40  20)
;    (3*N)+4

del40u:
ldi		temp2,d40u		; d40u  temp2

del40u_1:
dec		temp2			; temp2  1
brne	del40u_1		;    0,    del40u_1
ret						;  

;-----------------------  (~3  20)
;    (6*N)+9

del3m:
ldi		XL,low(d3m)		; 
ldi		XH,high(d3m)	; 
clr		temp2			; temp

del3m_1:
sbiw	X,1				;    X  1
cp		XL,temp2		;   0
cpc		XH,temp2		;   0,   
brne	del3m_1			;    0,    del3m_1
ret						;  

;-----------------------  (~20  20)
;    (6*N)+9

del20m:
ldi		XL,low(d20m)	; 
ldi		XH,high(d20m)	; 
clr		temp2			; temp

del20m_1:
sbiw	X,1				;    X  1
cp		XL,temp2		;   0
cpc		XH,temp2		;   0,   
brne	del20m_1		;    0,    del20m_1
ret						;  

;-----------------------  (~300  20)

del300m:
ldi		temp,15			; 

del300m_1:
rcall	del20m			;   (~20)
dec		temp			; temp  1
cpi		temp,0			; temp  0
brne	del300m_1		; temp<>0,   del300m_1,  
ret						;  

;-----------------------    LCD

lcd_com:
cbi		PORTB,RS		;
in		temp,PORTB
andi	temp,0b00000011	; 00000011   
ori		temp,0b00001000	;  temp  00001000 (  + )
rcall	lcd_out			;  lcd_out
ret						;  

;-----------------------    LCD

lcd_dat:
sbi		PORTB,RS		;
in		temp,PORTB
andi	temp,0b00000011	; 00000011   
ori		temp,0b00001100	;  temp  00001100 (  + )
rcall	lcd_out			;  lcd_out
ret						;  

;-----------------------   LCD

lcd_out:
rcall	del1u			;   (~1)
sbi		PORTB,E			; 
push	lcd				; lcd  
andi	lcd,0b11110000	; 11110000    
or		lcd,temp		;  lcd  temp (  + )
out		PORTB,lcd		;   
rcall	del1u			;   (~1)
cbi		PORTB,E			; 
rcall	del40u			;   (~40)

sbi		PORTB,E			; 
pop		lcd				; lcd  
swap	lcd				;  
andi	lcd,0b11110000	; 11110000    
or		lcd,temp		;  lcd  temp (  + )
out		PORTB,lcd		;   
rcall	del1u			;   (~1)
cbi		PORTB,E			; 
rcall	del40u			;   (~40)
rcall	del40u			;   (~40)
ret						;  

;-----------------------    

;USART_ready:
;sbis	UCSRA,UDRE		; UDRE ,   . 
;rjmp	USART_ready		; USART_ready
;ret						;  

;-----------------------    EEPROM
;    temp2,    temp

EEPROM_write:
out		EEAR,temp2		;   EEAR
out		EEDR,temp		;    EEDR

EEPROM_write_1:
sbic	EECR,EEPE		; EERE ,   . 
rjmp	EEPROM_write_1	; EEPROM_write_1
sbi		EECR,EEMPE		;   EEPROM ( EEMPE)
sbi		EECR,EEPE		;    EEPROM ( EEPE)
rcall	del3m			;   (~3)
rcall	del3m			;   (~3)
ret						;  

;-----------------------   EEPROM
;    temp2,    temp2

EEPROM_read:
out		EEAR,temp2		;   EEAR

EEPROM_read_1:
sbic	EECR,EEPE		; EEPE ,   . 
rjmp	EEPROM_read_1	; EEPROM_read_1
sbi		EECR,EERE		;  EEPROM ( EERE)
in		temp2,EEDR		;    temp2
ret						;  

;-----------------------      

predel:
ldi		temp,1			; 1  temp
clr		temp2			; temp2

cpi		k_del,0			;    0 (clk/1),    predel5
breq	predel5			; 

cpi		k_del,1			;    1 (clk/8),    predel4
breq	predel4			; 

cpi		k_del,2			;    2 (clk/64),    predel3
breq	predel3			; 

cpi		k_del,3			;    3 (clk/256),    predel2
breq	predel2			; 

;-----------------------  8...1024   

predel1:
lsr		z2				;/2 ( /2)
ror		z1				;
lsr		z2				;/2 ( /4)
ror		z1				;

predel2:
lsr		z2				;/2 ( /2)
ror		z1				;
lsr		z2				;/2 ( /4)
ror		z1				;

predel3:
lsr		z2				;/2 ( /2)
ror		z1				;
lsr		z2				;/2 ( /4)
ror		z1				;
lsr		z2				;/2 ( /8)
ror		z1				;

predel4:
lsr		z2				;/2 ( /2)
ror		z1				;
lsr		z2				;/2 ( /4)
ror		z1				;
lsr		z2				;/2 ( /8)
ror		z1				;

predel5:
cp		z1,temp			; z1  temp
cpc		z2,temp2		; z2  temp2   
brsh	predel6			; z2+z1>=1,   predel6,  
clr		z1				; z1
clr		z2				; z2

predel6:
ret						;  

;-----------------------    ( )

otlad:
sbic	PIND,6			; PD6=0,   . 
rjmp	otlad_2			; otlad_2
rcall	del3m			;   (~3)
sbic	PIND,6			; PD6=0,   . 
rjmp	otlad_2			; otlad_2

rcall 	lcd_both_str	;     

otlad_1:
rcall	knop_off		;    

pop		temp			;  (    ret)
pop		temp			; 
rjmp	main			; main

otlad_2:
ret						;  

;-----------------------   

knop_off:
sbis	PIND,6			; PD6=1,   . 
rjmp	knop_off		; knop_off
rcall	del3m			;   (~3)
sbis	PIND,6			; PD6=1,   . 
rjmp	knop_off		; knop_off
ret						;  

;-----------------------   1-  7-   USART

;usart_1_7:
;rcall	USART_ready		;     
;ldi		temp,0x10		; 0x10  temp
;or		des_tysh,temp	;  des_tysh  temp,   des_tysh
;out		UDR,des_tysh	;  des_tysh  USART

;rcall	USART_ready		;     
;ldi		temp,0x20		; 0x20  temp
;or		tyshi,temp		;  tyshi  temp,   tyshi
;out		UDR,tyshi		;  tyshi  USART

;rcall	USART_ready		;     
;ldi		temp,0x30		; 0x30  temp
;or		sotni,temp		;  sotni  temp,   sotni
;out		UDR,sotni		;  sotni  USART

;rcall	USART_ready		;     
;ldi		temp,0x40		; 0x40  temp
;or		desyatki,temp	;  desyatki  temp,   desyatki
;out		UDR,desyatki	;  desyatki  USART

;rcall	USART_ready		;     
;ldi		temp,0x50		; 0x50  temp
;or		edinicy,temp	;  edinicy  temp,   edinicy
;out		UDR,edinicy		;  edinicy  USART

;rcall	USART_ready		;     
;ldi		temp,0x60		; 0x60  temp
;or		desyatye,temp	;  desyatye  temp,   desyatye
;out		UDR,desyatye	;  desyatye  USART

;rcall	USART_ready		;     
;ldi		temp,0x70		; 0x70  temp
;or		sotye,temp		;  sotye  temp,   sotye
;out		UDR,sotye		;  sotye  USART

;rcall	USART_ready		;     
;ret						;  

;-----------------------    

lcd_one_str:
ldi		lcd,0x4E		; "N"
rcall	lcd_dat			;

ldi		lcd,0x3A		; ":"
rcall	lcd_dat			;

ldi		lcd,0x30		;    
add		lcd,tyshi		;
rcall	lcd_dat			;  

ldi		lcd,0x30		;    
add		lcd,sotni		;
rcall	lcd_dat			;  

ldi		lcd,0x30		;    
add		lcd,desyatki	;
rcall	lcd_dat			;  

ldi		lcd,0x30		;    
add		lcd,edinicy	;
rcall	lcd_dat			;  

ldi		lcd,0x30		;     
add		lcd,desyatye	;
rcall	lcd_dat			;   

ldi		lcd,0x30		;     
add		lcd,sotye		;
rcall	lcd_dat			;   
ret						;  

;-----------------------      

lcd_both_str:
mov		c1,a1			;  a1  c1
mov		c2,a2			;  a2  c2
mov		c3,a3			;  a3  c3

;-----------------------     -

rcall	bin2dec			;      -

;-----------------------     U1 "1=     "

ldi		lcd,0x80		;  ( 1 )
rcall	lcd_com			;

rcall	lcd_one_str		;     

mov		c1,b1			;  b1  c1
mov		c2,b2			;  b2  c2
mov		c3,b3			;  b3  c3

;-----------------------     -

rcall	bin2dec			;      -

;-----------------------     U2 "2=     "

ldi		lcd,0xC0		;  ( 2 )
rcall	lcd_com			;

rcall	lcd_one_str		;     

ret						;  

;-----------------------      1
;    reti,      

ovtim1:
cli						;  
ldi		temp,3			; 3  temp
cp		c3,temp			; c3  temp
breq	ovtim1_0		; 3=3,   ovtim1_0,  
inc		c3				; c3  1
reti					;    

ovtim1_0:
sbi		PORTD,0			;    
sbi		PORTD,4			;    
sbi		PORTD,5			;  
ldi		temp,0b00000000	; 
out		TCCR1B,temp		;
pop		temp			;  (   clk_down,    reti)
pop		temp			; 
rjmp	clk_down		;  clk_down

;-----------------------     U1
;    reti,      

com_U1:
in		a1,TCNT1L		; 1-  n1
in		a2,TCNT1H		; 2-  n1
mov		a3,c3			;  c3  a3 3-  n1
ldi		temp,0b10000000	;     PD3 (U2)
out		GIMSK,temp		;
reti					;    

;-----------------------     U2

com_U2:
in		c1,TCNT1L		; 1-  n2
in		c2,TCNT1H		; 2-  n2
cli						;  
sbi		PORTD,0			;    
sbi		PORTD,4			;    
sbi		PORTD,5			;  
ldi		temp,0b00000000	; 
out		TCCR1B,temp		;
pop		temp			;  (    reti)
pop		temp			; 

;----------------------- (c2+c1)-(a2+a1)<0  (c2+c1)<>0

com_U2_0:
mov		b1,c1			;  b1  c1 (n2)
mov		b2,c2			;  b2  c2
mov		b3,c3			;  b3  c3
sub		c1,a1			;  n2-n1
sbc		c2,a2			;  c3+c2+c1
sbc		c3,a3			;

cpi		tok_zar,0		; tok_zar  0
breq	com_U2_0_1		; tok_zar=0,   com_U2_0_1,  

com_U2_0_0:
ldi		temp,255		; 255 temp
rjmp	com_U2_0_2		; com_U2_0_2

com_U2_0_1:
ldi		temp,30			; 30 temp

com_U2_0_2:
clr		temp2			; temp2
cp		c1,temp			; c1  temp
cpc		c2,temp2		; c2  temp2   
cpc		c3,temp2		; c3  temp2   
brlo	com_U2_1		; (c2+c1)<30(255),   com_U2_1,  

rcall	otlad			;     ( )

rjmp	step1			; step1

;-----------------------

com_U2_1:
cpi		k_del,0			; k_del  0
breq	com_U2_2		; k_del=0,   com_U2_2,  
rjmp	com_U2_5		; com_U2_5

com_U2_2:
cpi		tok_zar,0		; tok_zar  0
breq	com_U2_2_0		; tok_zar=0,   com_U2_2_0,  
clr		tok_zar			; tok_zar
rjmp	com_U2_5		; com_U2_5

com_U2_2_0:
sbic	PIND,6			; PD6=0,   . 
rjmp	com_U2_5		; com_U2_5
rcall	del3m			;   (~3)
sbic	PIND,6			; PD6=0,   . 
rjmp	com_U2_5		; com_U2_5

;-----------------------    EEPROM

ldi		temp2,flag		;  temp2    EEPROM
rcall	EEPROM_read		;    EEPROM

cpi		temp2,100		; temp2  100
brne	com_U2_3		; temp2<>100,   com_U2_3,  

;-----------------------    EEPROM

ldi		temp,0xFF		; 0xFF  temp
ldi		temp2,flag		;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM

;----------------------- ". "  ".   "

ldi		ZL,low(Popr_off*2)	;  ZL       Popr_off ( )
ldi		ZH,high(Popr_off*2)	;  ZH       Popr_off ( )
rcall	lcd_all			;       LCD    

rcall	knop_off		;    

rjmp	main			; main

;-----------------------  EEPROM

;----------------------- n1 (1-  2- )

com_U2_3:
mov		temp,a1			; a1  temp
ldi		temp2,n1_1b		;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM

mov		temp,a2			; a2  temp
ldi		temp2,n1_2b		;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM

;----------------------- n2 (1-  2- )

mov		temp,b1			; b1  temp
ldi		temp2,n2_1b		;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM

mov		temp,b2			; b2  temp
ldi		temp2,n2_2b		;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM

;----------------------- n2-n1 (1-  2- )

mov		temp,c1			; c1  temp
ldi		temp2,n2_n1_1b	;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM

mov		temp,c2			; c2  temp
ldi		temp2,n2_n1_2b	;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM

;-----------------------    EEPROM

ldi		temp,100		; 100  temp
ldi		temp2,flag		;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM

rcall 	lcd_both_str	;     

;-----------------------    EEPROM   

rcall	knop_off		;    

ldi		ZL,low(Popr_on*2)	;  ZL       Popr_on ( )
ldi		ZH,high(Popr_on*2)	;  ZH       Popr_on ( )
rcall	lcd_all				;       LCD    
rcall	del300m				;   (~300)

rjmp	main				; main

;----------------------- "Cx < min"  "Rx > max"

com_U2_5:
ldi		ZL,low(Cmn_Rmx*2)	;  ZL       min_Rmax ( )
ldi		ZH,high(Cmn_Rmx*2)	;  ZH       min_Rmax ( )
rcall	lcd_all				;       LCD    
;inc		autoff				; autoff  1

;-----------------------  "Cx < min"  "ESR > max"

;rcall	USART_ready		;     

;ldi		temp,0xD1		; 0xD1  temp
;out		UDR,temp		;  temp  USART

;rcall	USART_ready		;     

rjmp	clk_up			;    ( clk_up)

;----------------------- 

Prvt:
.db	0x43,0x20,0x26,0x20,0x45,0x53,0x52,0x20 	;"C & ESR "
.db	0xB3,0x65,0x70,0x2E,0x20,0x31,0x2E,0x30 	;". 1.0"

Pred:
.db	0xA8,0x70,0x65,0xE3,0x65,0xBB,0x3A,0x20 	;": "
.db	0xB6,0xE3,0xB8,0xBF,0x65,0x2E,0x2E,0x2E 	;"..."

Cmn_Rmx:
.db	0x43,0x78,0x20,0x3C,0x20,0x6D,0x69,0x6E 	;"Cx < min"
.db	0x45,0x53,0x52,0x3E,0x20,0x6D,0x61,0x78		;"ESR> max"

ESRmn:
.db	0x3C,0x30,0x2C,0x30,0x31,0x20,0x4F,0xBC 	;"<0,01 "

ESRmx:
.db	0x3E,0x32,0x30,0x2C,0x30,0x20,0x4F,0xBC 	;">20,0 "

KZ_Cmx:
.db	0x43,0x78,0x20,0x3E,0x20,0x6D,0x61,0x78		;"Cx > max"
.db	0xB8,0xBB,0xB8,0x20,0x4B,0xA4,0x20,0x20 	;"   "

Popr_on:
.db	0xA8,0x6F,0xBE,0x70,0x61,0xB3,0xBA,0x61 	;""
.db	0xB3,0xBA,0xBB,0xC6,0xC0,0x65,0xBD,0x61		;""

Popr_off:
.db	0xA8,0x6F,0xBE,0x70,0x61,0xB3,0xBA,0x61 	;""
.db	0x63,0xB2,0x70,0x6F,0xC1,0x65,0xBD,0x61		;""

;Bat:
;.db	0xA4,0x61,0xBC,0x65,0xBD,0xB8,0xBF,0x65 	;""
;.db 0xB2,0x61,0xBF,0x61,0x70,0x65,0xC6,0x21 	;"!"

;Gdit:
;.db	0xB6,0xE3,0xB8,0xBF,0x65,0x2E,0x2E,0x2E 	;"..."
